Bug 1003950 - Use of uninitialized values on 64 bit machines.
Use of uninitialized values on 64 bit machines.
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: lcms (Show other bugs)
20
x86_64 Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Andreas Bierfert
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-09-03 10:46 EDT by Jaroslav Škarvada
Modified: 2015-04-23 12:08 EDT (History)
2 users (show)

See Also:
Fixed In Version: lcms-1.19-13.fc20
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-04-23 12:08:07 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Proposed fix (866 bytes, patch)
2013-09-03 10:46 EDT, Jaroslav Škarvada
no flags Details | Diff

  None (edit)
Description Jaroslav Škarvada 2013-09-03 10:46:25 EDT
Created attachment 793230 [details]
Proposed fix

Description of problem:
The ReadEmbeddedTextTag (src/cmsio1.c) expects wchar_t to be 16 bits long, but it can be 32 bits long (on 64 bit machines) which can cause read of multiple uninitialized values. It shouldn't happen, but it is probably harmless in this case (I didn't analyse the possible consequences more deep).

Version-Release number of selected component (if applicable):
lcms-1.19-9.fc19.x86_64

How reproducible:
Always

Steps to Reproduce:
1. valgrind geeqie test.svg   # with ICC activated

Actual results:
==9154== Conditional jump or move depends on uninitialised value(s)
==9154==    at 0x53F2345: wcsnlen (wcsnlen.c:33)
==9154==    by 0x53F1CBF: wcsrtombs (wcsrtombs.c:109)
==9154==    by 0x53899C0: wcstombs (wcstombs.c:34)
==9154==    by 0x380060ED0E: ReadEmbeddedTextTag (stdlib.h:154)
==9154==    by 0x3800613804: cmsReadICCTextEx (cmsio1.c:1696)
==9154==    by 0x380061457C: cmsTakeProductName (cmsio1.c:2184)
==9154==    by 0x43CA31: color_man_get_profile_name (color-man.c:428)
==9154==    by 0x43CCBD: color_man_get_status (color-man.c:446)
==9154==    by 0x46A607: layout_image_color_profile_get_status (layout_image.c:1145)
==9154==    by 0x46EE57: layout_util_sync_color (layout_util.c:2313)
==9154==    by 0x463A0E: layout_status_update_image (layout.c:534)
==9154==    by 0x4588F5: image_change_pixbuf (image.c:91)

Expected results:
No messages about uninitialized values.

Additional info:
The same problem is probably in rawhide.

The proposed fix is attached. Probably the better fix (but less compatible) would be to use char16_t from the 2011 revision of the standard.
Comment 1 Fedora End Of Life 2015-01-09 14:42:34 EST
This message is a notice that Fedora 19 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 19. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained. Approximately 4 (four) weeks from now this bug will
be closed as EOL if it remains open with a Fedora 'version' of '19'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 19 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 2 Fedora Update System 2015-02-03 03:58:58 EST
lcms-1.19-13.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/lcms-1.19-13.fc20
Comment 3 Fedora Update System 2015-02-04 03:00:10 EST
Package lcms-1.19-13.fc20:
* should fix your issue,
* was pushed to the Fedora 20 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing lcms-1.19-13.fc20'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2015-1648/lcms-1.19-13.fc20
then log in and leave karma (feedback).
Comment 4 Fedora Update System 2015-04-23 12:08:07 EDT
lcms-1.19-13.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.